local s=require("nixio.fs")
local h=Map("uhttpd",translate("uHTTPd"),
translate("A lightweight single-threaded HTTP(S) server"))
local e=h:section(TypedSection,"uhttpd","")
e.addremove=true
e.anonymous=false
local a=nil
local t=nil
local i=nil
local n=nil
e:tab("general",translate("General Settings"))
e:tab("server",translate("Full Web Server Settings"),translate("For settings primarily geared to serving more than the web UI"))
e:tab("advanced",translate("Advanced Settings"),translate("Settings which are either rarely needed or which affect serving the WebUI"))
a=e:taboption("general",DynamicList,"listen_http",translate("HTTP listeners (address:port)"),translate("Bind to specific interface:port (by specifying interface address"))
a.datatype="list(ipaddrport(1))"
function a.validate(s,n,e)
local i=false
local o=false
if a and a:formvalue(e)and(#(a:formvalue(e))>0)then
for t,e in pairs(a:formvalue(e))do
if e and(e~="")then
o=true
break
end
end
end
if t and t:formvalue(e)and(#(t:formvalue(e))>0)then
for t,e in pairs(t:formvalue(e))do
if e and(e~="")then
i=true
break
end
end
end
if not(o or i)then
return nil,"must listen on at least one address:port"
end
return DynamicList.validate(s,n,e)
end
t=e:taboption("general",DynamicList,"listen_https",translate("HTTPS listener (address:port)"),translate("Bind to specific interface:port (by specifying interface address"))
t.datatype="list(ipaddrport(1))"
t:depends("cert")
t:depends("key")
function t.validate(d,r,e)
local s=false
local h=false
if t and t:formvalue(e)and(#(t:formvalue(e))>0)then
for t,e in pairs(t:formvalue(e))do
if e and(e~="")then
s=true
break
end
end
if s and((not i)or(not i:formvalue(e))or(i:formvalue(e)==""))then
return nil,"must have certificate when using https"
end
if s and((not n)or(not n:formvalue(e))or(n:formvalue(e)==""))then
return nil,"must have key when using https"
end
end
if a and(a:formvalue(e))and(#a:formvalue(e)>0)then
for t,e in pairs(a:formvalue(e))do
if e and(e~="")then
h=true
break
end
end
end
if not(h or s)then
return nil,"must listen on at least one address:port"
end
return DynamicList.validate(d,r,e)
end
o=e:taboption("general",Flag,"redirect_https",translate("Redirect all HTTP to HTTPS"))
o.default=o.enabled
o.rmempty=false
o=e:taboption("general",Flag,"rfc1918_filter",translate("Ignore private IPs on public interface"),translate("Prevent access from private (RFC1918) IPs on an interface if it has an public IP address"))
o.default=o.enabled
o.rmempty=false
i=e:taboption("general",FileUpload,"cert",translate("HTTPS Certificate (DER or PEM format)"))
n=e:taboption("general",FileUpload,"key",translate("HTTPS Private Key (DER or PEM format)"))
o=e:taboption("general",Button,"remove_old",translate("Remove old certificate and key"),
translate("uHTTPd will generate a new self-signed certificate using the configuration shown below."))
o.inputstyle="remove"
function o.write(t,e)
if i:cfgvalue(e)and s.access(i:cfgvalue(e))then s.unlink(i:cfgvalue(e))end
if n:cfgvalue(e)and s.access(n:cfgvalue(e))then s.unlink(n:cfgvalue(e))end
luci.sys.call("/etc/init.d/uhttpd restart")
luci.http.redirect(luci.dispatcher.build_url("admin","services","uhttpd"))
end
o=e:taboption("general",Button,"remove_conf",translate("Remove configuration for certificate and key"),
translate("This permanently deletes the cert, key, and configuration to use same."))
o.inputstyle="remove"
function o.write(t,e)
if i:cfgvalue(e)and s.access(i:cfgvalue(e))then s.unlink(i:cfgvalue(e))end
if n:cfgvalue(e)and s.access(n:cfgvalue(e))then s.unlink(n:cfgvalue(e))end
t.map:del(e,"cert")
t.map:del(e,"key")
t.map:del(e,"listen_https")
luci.http.redirect(luci.dispatcher.build_url("admin","services","uhttpd"))
end
o=e:taboption("server",DynamicList,"index_page",translate("Index page(s)"),translate("E.g specify with index.html and index.php when using PHP"))
o.optional=true
o.placeholder="index.html"
o=e:taboption("server",DynamicList,"interpreter",translate("CGI filetype handler"),translate("Interpreter to associate with file endings ('suffix=handler', e.g. '.php=/usr/bin/php-cgi')"))
o.optional=true
o=e:taboption("server",Flag,"no_symlinks",translate("Do not follow symlinks outside document root"))
o.optional=true
o=e:taboption("server",Flag,"no_dirlists",translate("Do not generate directory listings."))
o.default=o.disabled
o=e:taboption("server",DynamicList,"alias",translate("Aliases"),translate("(/old/path=/new/path) or (just /old/path which becomes /cgi-prefix/old/path)"))
o.optional=true
o=e:taboption("server",Value,"realm",translate("Realm for Basic Auth"))
o.optional=true
o.placeholder=luci.sys.hostname()or"OpenWrt"
local t=e:taboption("server",Value,"config",translate("Config file (e.g. for credentials for Basic Auth)"),translate("Will not use HTTP authentication if not present"))
t.optional=true
o=e:taboption("server",Value,"error_page",translate("404 Error"),translate("Virtual URL or CGI script to display on status '404 Not Found'.  Must begin with '/'"))
o.optional=true
o=e:taboption("advanced",Value,"home",translate("Document root"),
translate("Base directory for files to be served"))
o.default="/www"
o.datatype="directory"
o=e:taboption("advanced",Value,"cgi_prefix",translate("Path prefix for CGI scripts"),translate("CGI is disabled if not present."))
o.optional=true
o=e:taboption("advanced",Value,"lua_prefix",translate("Virtual path prefix for Lua scripts"))
o.placeholder="/lua"
o.optional=true
o=e:taboption("advanced",Value,"lua_handler",translate("Full real path to handler for Lua scripts"),translate("Embedded Lua interpreter is disabled if not present."))
o.optional=true
o=e:taboption("advanced",Value,"ubus_prefix",translate("Virtual path prefix for ubus via JSON-RPC integration"),translate("ubus integration is disabled if not present"))
o.optional=true
o=e:taboption("advanced",Value,"ubus_socket",translate("Override path for ubus socket"))
o.optional=true
o=e:taboption("advanced",Flag,"ubus_cors",translate("Enable JSON-RPC Cross-Origin Resource Support"))
o.default=o.disabled
o.optional=true
o=e:taboption("advanced",Flag,"no_ubusauth",translate("Disable JSON-RPC authorization via ubus session API"))
o.optional=true
o.default=o.disabled
o=e:taboption("advanced",Value,"script_timeout",translate("Maximum wait time for Lua, CGI, or ubus execution"))
o.placeholder=60
o.datatype="uinteger"
o.optional=true
o=e:taboption("advanced",Value,"network_timeout",translate("Maximum wait time for network activity"))
o.placeholder=30
o.datatype="uinteger"
o.optional=true
o=e:taboption("advanced",Value,"http_keepalive",translate("Connection reuse"))
o.placeholder=20
o.datatype="uinteger"
o.optional=true
o=e:taboption("advanced",Value,"tcp_keepalive",translate("TCP Keepalive"))
o.optional=true
o.datatype="uinteger"
o.default=1
o=e:taboption("advanced",Value,"max_connections",translate("Maximum number of connections"))
o.optional=true
o.datatype="uinteger"
o=e:taboption("advanced",Value,"max_requests",translate("Maximum number of script requests"))
o.optional=true
o.datatype="uinteger"
local e=h:section(TypedSection,"cert",translate("uHTTPd Self-signed Certificate Parameters"))
e.template="cbi/tsection"
e.anonymous=true
o=e:option(Value,"days",translate("Valid for # of Days"))
o.default=730
o.datatype="uinteger"
o=e:option(Value,"bits",translate("Length of key in bits"))
o.default=2048
o.datatype="min(1024)"
o=e:option(Value,"commonname",translate("Server Hostname"),translate("a.k.a CommonName"))
o.default=luci.sys.hostname()
o=e:option(Value,"organization",translate("Organization"),translate("If empty, a random/unique value is used in cert generation"))
o=e:option(Value,"location",translate("Location"))
o.default="Unknown"
o=e:option(Value,"state",translate("State"))
o.default="Unknown"
o=e:option(Value,"country",translate("Country"))
o.default="ZZ"
return h
